﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Data;
using Telerik.Windows.Controls;
using System.Collections.ObjectModel;

namespace SortDistinctFilterValues
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.clubsGrid.DistinctValuesLoading += ClubsGrid_DistinctValuesLoading;
        }

        private void ClubsGrid_DistinctValuesLoading(object sender, Telerik.Windows.Controls.GridView.GridViewDistinctValuesLoadingEventArgs e)
        {
            var gridView = sender as RadGridView;
            if (e.Column.SortingState == SortingState.Descending)
            {
                e.ItemsSource = gridView.GetDistinctValues(e.Column, true).OfType<object>().OrderByDescending(x => x);
            }
            else if (e.Column.SortingState == SortingState.Ascending)
            {
                e.ItemsSource = gridView.GetDistinctValues(e.Column, true).OfType<object>().OrderBy(x => x);
            }
            else
            {
                var clubs = new List<Club>();
                foreach (var item in gridView.Items)
                {
                    clubs.Add(item as Club);
                }

                var propertyName = (e.Column as GridViewBoundColumnBase).DataMemberBinding.Path.Path;
                e.ItemsSource = clubs.Select((c) => typeof(Club).GetProperty(propertyName).GetValue(c)).Distinct();
            }
        }

        private void Button1_Click(object sender, RoutedEventArgs e)
        {

        }

        private void Button2_Click(object sender, RoutedEventArgs e)
        {

        }
    }
}
